﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.UI.Core;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;

namespace InkrementellesLaden
{
  public class IncrementalFriendCollection : ObservableCollection<Friend>, ISupportIncrementalLoading
  {

    public int MaxFriends { get { return 100; } }
    public bool HasMoreItems
    {
      get { return this.Count < MaxFriends; }
    }

    public IAsyncOperation<LoadMoreItemsResult> LoadMoreItemsAsync(uint count)
    {
      int numberOfUnloadedItems = MaxFriends - this.Count;
      int itemsToLoadForThisCall = (int)Math.Min(count, numberOfUnloadedItems);
      return InternalLoad(itemsToLoadForThisCall).AsAsyncOperation();
    }

    private async Task<LoadMoreItemsResult> InternalLoad(int itemsToLoad)
    {
      for (int i = 0; i < itemsToLoad; i++)
      {
        // Künstlich etwas Verzögerung einbauen, um den Nachladevorgang für Web-Ressourcen besser zu simulieren
        await Task.Delay(100);

        await Window.Current.CoreWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal,
            () => this.Add(new Friend { FirstName = "Thomas der " + (this.Count + 1) }));
      }
      return new LoadMoreItemsResult { Count = (uint)itemsToLoad };
    }
  }
}
